/* source-pane-view.c generated by valac 0.10.0, the Vala compiler
 * generated from source-pane-view.vala, do not modify */

/*
 * Copyright (c) 2010, Nate Stedman <natesm@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>


#define SOURCE_TYPE_BASE_VIEW (source_base_view_get_type ())
#define SOURCE_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_TYPE_BASE_VIEW, SourceBaseView))
#define SOURCE_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_TYPE_BASE_VIEW, SourceBaseViewClass))
#define SOURCE_IS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_TYPE_BASE_VIEW))
#define SOURCE_IS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_TYPE_BASE_VIEW))
#define SOURCE_BASE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_TYPE_BASE_VIEW, SourceBaseViewClass))

typedef struct _SourceBaseView SourceBaseView;
typedef struct _SourceBaseViewClass SourceBaseViewClass;
typedef struct _SourceBaseViewPrivate SourceBaseViewPrivate;

#define SOURCE_TYPE_LIST (source_list_get_type ())
#define SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_TYPE_LIST, SourceList))
#define SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_TYPE_LIST, SourceListClass))
#define SOURCE_IS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_TYPE_LIST))
#define SOURCE_IS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_TYPE_LIST))
#define SOURCE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_TYPE_LIST, SourceListClass))

typedef struct _SourceList SourceList;
typedef struct _SourceListClass SourceListClass;

#define SOURCE_TYPE_PANE_VIEW (source_pane_view_get_type ())
#define SOURCE_PANE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_TYPE_PANE_VIEW, SourcePaneView))
#define SOURCE_PANE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_TYPE_PANE_VIEW, SourcePaneViewClass))
#define SOURCE_IS_PANE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_TYPE_PANE_VIEW))
#define SOURCE_IS_PANE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_TYPE_PANE_VIEW))
#define SOURCE_PANE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_TYPE_PANE_VIEW, SourcePaneViewClass))

typedef struct _SourcePaneView SourcePaneView;
typedef struct _SourcePaneViewClass SourcePaneViewClass;
typedef struct _SourcePaneViewPrivate SourcePaneViewPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SourceBaseView {
	GtkAlignment parent_instance;
	SourceBaseViewPrivate * priv;
	GtkAlignment* bin;
	SourceList* list;
};

struct _SourceBaseViewClass {
	GtkAlignmentClass parent_class;
};

struct _SourcePaneView {
	SourceBaseView parent_instance;
	SourcePaneViewPrivate * priv;
};

struct _SourcePaneViewClass {
	SourceBaseViewClass parent_class;
};


static gpointer source_pane_view_parent_class = NULL;

GType source_base_view_get_type (void) G_GNUC_CONST;
GType source_list_get_type (void) G_GNUC_CONST;
GType source_pane_view_get_type (void) G_GNUC_CONST;
enum  {
	SOURCE_PANE_VIEW_DUMMY_PROPERTY
};
SourcePaneView* source_pane_view_new (gboolean with_separator);
SourcePaneView* source_pane_view_construct (GType object_type, gboolean with_separator);
SourceBaseView* source_base_view_construct (GType object_type);



/**
 * Creates an empty Source.View. Add groups with add_group().
 *
 * @param with_separator If true, a Gtk.Separator is included to the right
 * of the drag handle.
 */
#line 31 "source-pane-view.vala"
SourcePaneView* source_pane_view_construct (GType object_type, gboolean with_separator) {
#line 102 "source-pane-view.c"
	SourcePaneView * self;
	GtkHPaned* hpane;
#line 34 "source-pane-view.vala"
	self = (SourcePaneView*) source_base_view_construct (object_type);
#line 37 "source-pane-view.vala"
	hpane = g_object_ref_sink ((GtkHPaned*) gtk_hpaned_new ());
#line 38 "source-pane-view.vala"
	gtk_paned_pack1 ((GtkPaned*) hpane, (GtkWidget*) ((SourceBaseView*) self)->list, FALSE, FALSE);
#line 41 "source-pane-view.vala"
	if (with_separator) {
#line 113 "source-pane-view.c"
		GtkHBox* hbox;
		GtkVSeparator* _tmp0_;
#line 43 "source-pane-view.vala"
		hbox = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
#line 44 "source-pane-view.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) (_tmp0_ = g_object_ref_sink ((GtkVSeparator*) gtk_vseparator_new ())), FALSE, FALSE, (guint) 0);
#line 120 "source-pane-view.c"
		_g_object_unref0 (_tmp0_);
#line 45 "source-pane-view.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) ((SourceBaseView*) self)->bin, TRUE, TRUE, (guint) 0);
#line 46 "source-pane-view.vala"
		gtk_paned_pack2 ((GtkPaned*) hpane, (GtkWidget*) hbox, TRUE, FALSE);
#line 126 "source-pane-view.c"
		_g_object_unref0 (hbox);
	} else {
#line 52 "source-pane-view.vala"
		gtk_paned_pack2 ((GtkPaned*) hpane, (GtkWidget*) ((SourceBaseView*) self)->bin, TRUE, FALSE);
#line 131 "source-pane-view.c"
	}
#line 56 "source-pane-view.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) hpane);
#line 135 "source-pane-view.c"
	_g_object_unref0 (hpane);
	return self;
}


#line 31 "source-pane-view.vala"
SourcePaneView* source_pane_view_new (gboolean with_separator) {
#line 31 "source-pane-view.vala"
	return source_pane_view_construct (SOURCE_TYPE_PANE_VIEW, with_separator);
#line 145 "source-pane-view.c"
}


static void source_pane_view_class_init (SourcePaneViewClass * klass) {
	source_pane_view_parent_class = g_type_class_peek_parent (klass);
}


static void source_pane_view_instance_init (SourcePaneView * self) {
}


/**
 * An implementation of {@link Source.BaseView} with a Gtk.HPaned
 *
 * Source.View consists of a {@link Source.List}, a separator, and a Gtk.Bin
 * packed into a Gtk.HBox.
 */
GType source_pane_view_get_type (void) {
	static volatile gsize source_pane_view_type_id__volatile = 0;
	if (g_once_init_enter (&source_pane_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourcePaneViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_pane_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourcePaneView), 0, (GInstanceInitFunc) source_pane_view_instance_init, NULL };
		GType source_pane_view_type_id;
		source_pane_view_type_id = g_type_register_static (SOURCE_TYPE_BASE_VIEW, "SourcePaneView", &g_define_type_info, 0);
		g_once_init_leave (&source_pane_view_type_id__volatile, source_pane_view_type_id);
	}
	return source_pane_view_type_id__volatile;
}




